| RNAstructure Classes Version 6.2

Public Member Functions | Private Member Functions | Private Attributes | List of all members
Multifind_object Class Reference

Multifind_object Class. More...

`#include <Multifind_object.h>`

Inheritance diagram for Multifind_object:

## Public Member Functions
| Multifind_object (const string &outputmultifind, const vector< string > &ctfiles, const vector< string > &inputalignment, const vector< string > &inputsequences, const int &processors, ProgressHandler *progress=NULL)
int | Multifind_Predict ()
| The core function doing Multilign calculation and SVM prediction. More...
Public Member Functions inherited from Multilign_object
| Multilign_object ()
| Default constructor: More...
| Multilign_object (const vector< vector< string > > &inputlist, const bool isrna=true, ProgressHandler *progress=NULL)
| Multilign_object (const bool Multifind, const string &outputmultifind, const vector< string > &ctfiles, ProgressHandler *progress=NULL, const bool isrna=true)
| ~Multilign_object ()
int | CountBP (const int i=0, const int j=0, const double percent=0.8) const
| count the number of basepairs with the lowest free energies below the percent of the miminal free energy. Dsv file is used for the counting. By default, the first dsv file in the progressive dynalign calculations is used, i.e. i = 0 and j = 0. More...
int | ProgressiveMultilign (const short int numProcessors=1, const bool Dsv=1, const bool Ali=1, const short int maxtrace=750, const short int bpwin=2, const short int awin=1, const short int percent=20, const short int imaxseparation=-99, const float gap=0.4, const bool singleinsert=true, const short int singlefold_subopt_percent=30, const bool local=false)
int | MultiTempMultilign ()
int | WriteAlignment (const string allali="all.ali") const
| calculate and output multiple alignment More...
int | GetErrorCode () const
| Return an error code, where a return of zero is no error. More...
string | GetErrorMessage (const int error) const
const string | GetErrorDetails ()
void | ResetError ()
| Reset the underlying RNA objects internal error code, after an error is handled. More...
int | SetMaxPairs (const int maxpairs=-1)
int | GetMaxPairs () const
| get the value of MaxPairs More...
int | AverageLength () const
| get the average length of the input sequences More...
int | SetIterations (const int it=2)
| set the value of iterations More...
int | GetIterations () const
| get the value of iterations More...
int | SetMaxDsv (const float maxdsvchange=1)
| set the value of MaxDsv/maxdsvchange More...
float | GetMaxDsv () const
| get the value of MaxDsv/maxdsvchange More...
int | GetSequenceNumber () const
| get the sequence number More...
int | SetIndexSeq (size_t indexSeq=1)
| set the Index Sequence for Multilign calculation. More...
int | SetIndexSeq (const string seqname)
| an overloaded function accepting a string as its parameter. More...
string | GetIndexSeq () const
| return the filename of the index seq. More...
void | Randomize ()
| randomize the order of inputList. More...
int | AddOneInput (const string seq, const string ct, const string constraint="", const string shape="")
| add one entry into inputList. More...
int | RemoveOneInput (const string seq)
| remove one entry from inputList. More...
void | SetSHAPESlope (const double slope=1.8)
| set the slope parameter for SHAPE More...
double | GetSHAPESlope () const
| get the SHAPESlope More...
void | SetSHAPEIntercept (const double intercept=-0.6)
| set the intercept parameter for SHAPE. More...
double | GetSHAPEIntercept () const
| get the SHAPEIntercept. More...
void | SetTemperature (const double temp=310.15)
| set the temperature to fold the sequences. More...
double | GetTemperature () const
| get the temperature to fold the sequences More...
int | CleanupIntermediateFiles () const
| set the flag isRNA to be true or false. By default it is true. When it is true, RNA nearest neighbor parameters are used. More...
void | SetProgress (ProgressHandler *Progress=NULL)
| Provide a TProgressDialog for following calculation progress. More...
void | StopProgress ()
| Provide a means to stop using a TProgressDialog by assigning NULL to progress pointer. More...
ProgressHandler * | GetProgress () const
| get the progress More...
void | GetInputFilenames ()
| For diagnostic purpose only. Output the input sequence, ct, constraints, and SHAPE filenames to stdout. More...
void | GetPairs ()
| For diagnostic purpose only. Output the paired sequence filenames to stdout. More...
vector< float > | get_energies ()
vector< float > | get_dGIndex ()
vector< vector< string > > | get_pair_alignments ()

## Private Member Functions
double | sum_multifind (vector< double > &series)
double | average_multifind (vector< double > &series)
double | variation_multifind (vector< double > &series)
double | sum_multifind (vector< float > &series)
double | average_multifind (vector< float > &series)
double | variation_multifind (vector< float > &series)
double | sum_multifind (vector< int > &series)
double | average_multifind (vector< int > &series)
double | variation_multifind (vector< int > &series)
double | normalized_ensemble_defect (RNA *rna)
double | entropy (vector< char > column)
double | average_entropy ()
vector< double > | single_z_predict (string sequence, svm_model *model_folding_average, svm_model *model_folding_std, svm_model *model_ensemble_average, svm_model *model_ensemble_std)
int | get_gap (string sequence)
double | common_energies ()
vector< double > | predict_ncRNA_probabilities (double sci, double entropy, double single_z, double ensemble_defect_z)

## Private Attributes
int | num_processors

## Additional Inherited Members
Protected Attributes inherited from Multilign_object
int | ErrorCode
vector< string > | input_alignment
vector< string > | input_sequences
vector< string > | ct_files
string | output_multifind
vector< float > | energies
vector< float > | dGIndex
vector< vector< string > > | pair_alignments

## Detailed Description

Multifind_object Class.

The Multifind_object class provides an entry point for the Multifind algorithm.

## Constructor & Destructor Documentation

## ◆ Multifind_object()

Multifind_object::Multifind_object | ( | const string & | outputmultifind,
|  | const vector< string > & | ctfiles,
|  | const vector< string > & | inputalignment,
|  | const vector< string > & | inputsequences,
|  | const int & | processors,
|  | ProgressHandler * | progress = `NULL`
| ) |  |

Constructor:

Parameters

  outputmultifind | is the name of the Multifind output file to which the output is written to.
  ctfiles | is a vector of strings storing the names of the ct files to which the output structures are written to.
  inputalignment | is a vector of strings storing the input sequences in the alignment (with gaps).
  inputsequences | is a vector of strings storing the input sequences in the alignment (without gaps).
  processors | is a interger indicating the number of processors required by Multifind in smp calculations.(only applicable in smp version)
  progress | is a TProgressDialog for reporting progress of the calculation to the user. The default value of NULL means that no communication is provided.

## Member Function Documentation

## ◆ average_entropy()

double Multifind_object::average_entropy | ( |  | ) |
| private

## ◆ average_multifind() [1/3]

double Multifind_object::average_multifind | ( | vector< double > & | series | ) |
| private

## ◆ average_multifind() [2/3]

double Multifind_object::average_multifind | ( | vector< float > & | series | ) |
| private

## ◆ average_multifind() [3/3]

double Multifind_object::average_multifind | ( | vector< int > & | series | ) |
| private

## ◆ common_energies()

double Multifind_object::common_energies | ( |  | ) |
| private

## ◆ entropy()

double Multifind_object::entropy | ( | vector< char > | column | ) |
| private

## ◆ get_gap()

int Multifind_object::get_gap | ( | string | sequence | ) |
| private

## ◆ Multifind_Predict()

int Multifind_object::Multifind_Predict | ( |  | ) |

The core function doing Multilign calculation and SVM prediction.

## ◆ normalized_ensemble_defect()

double Multifind_object::normalized_ensemble_defect | ( | RNA * | rna | ) |
| private

## ◆ predict_ncRNA_probabilities()

vector< double > Multifind_object::predict_ncRNA_probabilities | ( | double | sci,
|  | double | entropy,
|  | double | single_z,
|  | double | ensemble_defect_z
| ) |  |
| private

## ◆ single_z_predict()

vector< double > Multifind_object::single_z_predict | ( | string | sequence,
|  | svm_model * | model_folding_average,
|  | svm_model * | model_folding_std,
|  | svm_model * | model_ensemble_average,
|  | svm_model * | model_ensemble_std
| ) |  |
| private

## ◆ sum_multifind() [1/3]

double Multifind_object::sum_multifind | ( | vector< double > & | series | ) |
| private

## ◆ sum_multifind() [2/3]

double Multifind_object::sum_multifind | ( | vector< float > & | series | ) |
| private

## ◆ sum_multifind() [3/3]

double Multifind_object::sum_multifind | ( | vector< int > & | series | ) |
| private

## ◆ variation_multifind() [1/3]

double Multifind_object::variation_multifind | ( | vector< double > & | series | ) |
| private

## ◆ variation_multifind() [2/3]

double Multifind_object::variation_multifind | ( | vector< float > & | series | ) |
| private

## ◆ variation_multifind() [3/3]

double Multifind_object::variation_multifind | ( | vector< int > & | series | ) |
| private

## Member Data Documentation

## ◆ num_processors

int Multifind_object::num_processors
| private

The documentation for this class was generated from the following files:

- RNA_class/Multifind_object.h
- RNA_class/Multifind_object.cpp